' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/03/09 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmSetCircleRobust

    Private m_Circle As New FvCircle

    Private m_blnIsCircleSet As Boolean '~ݒς݂ǂ

    Private m_blnIsSelecting As Boolean 'WI𒆂H

    'W
    Private m_intPointDataX(100) As Integer
    Private m_intPointDataY(100) As Integer
    Private m_intPointNum As Integer      'W̌

    Private Sub frmSetCircleRobust_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        m_intPointNum = 0
        m_blnIsSelecting = True
        m_blnIsCircleSet = False

        frmMain.AxFvxImage1.CopyTo(Me.AxFvxImage1.GetOcx())
        AxFvxDisplayEx1.CreateDisplay()
        AxFvxDisplayEx1.DrawImage(Me.AxFvxImage1.GetOcx())

        lblMessage.Text = "w_ɑ΂ăoXgsAO~肵܂B" & vbCrLf & _
                              "~̓_RȏwAs{^Ă"

    End Sub

    '~ݒ肳ꂽǂׂ
    Public ReadOnly Property CheckCircle() As Boolean

        Get
            CheckCircle = m_blnIsCircleSet
        End Get

    End Property

    Public Sub GetCircle(ByVal pCircle As FvCircle)

        pCircle.x = m_Circle.x
        pCircle.y = m_Circle.y
        pCircle.radius = m_Circle.radius

    End Sub

    '_W̎w
    Private Sub AxFvxDisplayEx1_MouseDownEvent(ByVal sender As System.Object, ByVal e As AxFVXCOMDISPLAYEXLib._IFvxDisplayExEvents_MouseDownEvent) Handles AxFvxDisplayEx1.MouseDownEvent

        If m_blnIsSelecting = True Then

            If m_intPointNum < 100 Then
                m_intPointDataX(m_intPointNum) = e.x
                m_intPointDataY(m_intPointNum) = e.y

                DrawCrossMark(e.x, e.y)

                m_intPointNum = m_intPointNum + 1
            Else
                MsgBox("100_ȏ͎wł܂", , "G[")
            End If
        End If

    End Sub

    'LZ
    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click

        'LZ͖ݒԂɂďI
        m_blnIsCircleSet = False
        Me.Close()

    End Sub

    's
    Private Sub btnRobust_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRobust.Click

        Dim pPoint As New FvPoint
        Dim dblWeight As Double
        Dim dblTemp As Double
        Dim intErr As Integer
        Dim i As Integer

        m_blnIsSelecting = False

        If Integer.TryParse(txtRobustWeight.Text, dblTemp) = False Or dblTemp < 0 Then
            MsgBox("d݂̒lsł", vbExclamation, "G[")
            Exit Sub
        End If
        dblWeight = dblTemp

        If m_intPointNum >= 3 Then

            'W_Zbg
            For i = 0 To m_intPointNum - 1
                pPoint.x = m_intPointDataX(i)
                pPoint.y = m_intPointDataY(i)
                AxFvxCalcData1.SetPoint(i, pPoint)
            Next

            'oXg̎s
            AxFvxCalcData1.CalcCircle_Robust(m_intPointNum, dblWeight)
            'G[oĂȂ`FbN
            AxFvxCalcData1.GetErrReport(intErr)
            If intErr = 0 Then

                'ʂ擾
                AxFvxCalcData1.CalcCircle_GetResult(m_Circle)
                AxFvxDisplayEx1.DrawData(0, m_Circle)
                My.Application.DoEvents()

                If MsgBox("̌ʂŗǂłH", vbYesNo) = vbYes Then
                    '~肵Ã_CAOI
                    m_blnIsCircleSet = True
                    Me.Close()
                Else
                    'Wf[^NAāAĎw
                    AxFvxDisplayEx1.ClearOverlay()
                    m_blnIsCircleSet = False
                    m_blnIsSelecting = True
                    m_intPointNum = 0
                End If

            Else
                MsgBox("oXgɎs܂B" & vbCrLf & "Wf[^NA܂B", , "G[")
                'Wf[^NAčĎw
                AxFvxDisplayEx1.ClearOverlay()
                m_blnIsCircleSet = False
                m_blnIsSelecting = True
                m_intPointNum = 0
            End If
        Else
            MsgBox("w_Ȃ܂B", , "G[")
        End If

    End Sub

    '~}[N\܂
    Private Sub DrawCrossMark(ByVal int_x As Integer, ByVal int_y As Integer)

        Dim pLineSeg As New FvLineSegment

        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)

        pLineSeg.xs = int_x - 5
        pLineSeg.ys = int_y - 5
        pLineSeg.xe = int_x + 5
        pLineSeg.ye = int_y + 5
        AxFvxDisplayEx1.DrawData(0, pLineSeg)

        pLineSeg.xs = int_x - 5
        pLineSeg.ys = int_y + 5
        pLineSeg.xe = int_x + 5
        pLineSeg.ye = int_y - 5
        AxFvxDisplayEx1.DrawData(0, pLineSeg)

    End Sub

    Private Sub txtRobustWeight_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtRobustWeight.KeyPress

        'l'.'̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Or (e.KeyChar = Chr(&H2E)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub
End Class